library IEEE;
use IEEE.std_logic_1164.all;

entity camellia is
	port(
		data_in: in  STD_LOGIC_VECTOR (0 to 127);
		kljuc : in  STD_LOGIC_VECTOR (0 to 127);
		data_out: out  STD_LOGIC_VECTOR (0 to 127)
		);
end camellia;

architecture shema of camellia is

	signal data_in_int:STD_LOGIC_VECTOR (0 to 127);
	signal kljuc_int:STD_LOGIC_VECTOR (0 to 127);
	signal data_out_int:STD_LOGIC_VECTOR (0 to 127);
	type niz_registara is array (0 to 25) of std_logic_vector(0 to 63);
	signal kljucevi: niz_registara; 
	
	component key_scheduling is
        port(
			k: in STD_LOGIC_VECTOR (0 to 127);
			kw1: out STD_LOGIC_VECTOR (0 to 63);
			kw2: out STD_LOGIC_VECTOR (0 to 63);
			kw3: out STD_LOGIC_VECTOR (0 to 63);
			kw4: out STD_LOGIC_VECTOR (0 to 63);
			k1: out STD_LOGIC_VECTOR (0 to 63);
			k2: out STD_LOGIC_VECTOR (0 to 63);
			k3: out STD_LOGIC_VECTOR (0 to 63);
			k4: out STD_LOGIC_VECTOR (0 to 63);
			k5: out STD_LOGIC_VECTOR (0 to 63);
			k6: out STD_LOGIC_VECTOR (0 to 63);
			k7: out STD_LOGIC_VECTOR (0 to 63);
			k8: out STD_LOGIC_VECTOR (0 to 63);
			k9: out STD_LOGIC_VECTOR (0 to 63);
			k10: out STD_LOGIC_VECTOR (0 to 63);
			k11: out STD_LOGIC_VECTOR (0 to 63);
			k12: out STD_LOGIC_VECTOR (0 to 63);
			k13: out STD_LOGIC_VECTOR (0 to 63);
			k14: out STD_LOGIC_VECTOR (0 to 63);
			k15: out STD_LOGIC_VECTOR (0 to 63);
			k16: out STD_LOGIC_VECTOR (0 to 63);
			k17: out STD_LOGIC_VECTOR (0 to 63);
			k18: out STD_LOGIC_VECTOR (0 to 63);
			ke1: out STD_LOGIC_VECTOR (0 to 63);
			ke2: out STD_LOGIC_VECTOR (0 to 63);
			ke3: out STD_LOGIC_VECTOR (0 to 63);
			ke4: out STD_LOGIC_VECTOR (0 to 63)
			);
	end component;
	
	component data_randomizing is
        port(
			data_in: in  STD_LOGIC_VECTOR (0 to 127);
			k1: in    STD_LOGIC_VECTOR (0 to 63);
			k2: in    STD_LOGIC_VECTOR (0 to 63);
			k3: in    STD_LOGIC_VECTOR (0 to 63);
			k4: in    STD_LOGIC_VECTOR (0 to 63);
			k5: in    STD_LOGIC_VECTOR (0 to 63);
			k6: in    STD_LOGIC_VECTOR (0 to 63);
			k7: in    STD_LOGIC_VECTOR (0 to 63);
			k8: in    STD_LOGIC_VECTOR (0 to 63);
			k9: in    STD_LOGIC_VECTOR (0 to 63);
			k10: in    STD_LOGIC_VECTOR (0 to 63);
			k11: in    STD_LOGIC_VECTOR (0 to 63);
			k12: in    STD_LOGIC_VECTOR (0 to 63); 
			k13: in    STD_LOGIC_VECTOR (0 to 63);
			k14: in    STD_LOGIC_VECTOR (0 to 63);
			k15: in    STD_LOGIC_VECTOR (0 to 63);
			k16: in    STD_LOGIC_VECTOR (0 to 63);
			k17: in    STD_LOGIC_VECTOR (0 to 63);
			k18: in    STD_LOGIC_VECTOR (0 to 63);
			kw1: in    STD_LOGIC_VECTOR (0 to 63);
			kw2: in    STD_LOGIC_VECTOR (0 to 63);
			kw3: in    STD_LOGIC_VECTOR (0 to 63);
			kw4: in    STD_LOGIC_VECTOR (0 to 63);
			ke1: in    STD_LOGIC_VECTOR (0 to 63);
			ke2: in    STD_LOGIC_VECTOR (0 to 63);
			ke3: in    STD_LOGIC_VECTOR (0 to 63);
			ke4: in    STD_LOGIC_VECTOR (0 to 63);
			data_out: out  STD_LOGIC_VECTOR (0 to 127)
			);
	end component;
	
begin	

		data_in_int <= data_in ;		
		kljuc_int <= kljuc;
		
		
		key_scheduling_int: key_scheduling
		port map(
				k  => kljuc_int,
				kw1  => kljucevi(0),
				kw2  => kljucevi(1),
				k1  => kljucevi(2),
				k2  => kljucevi(3),
				k3  => kljucevi(4),
				k4  => kljucevi(5),
				k5  => kljucevi(6),
				k6  => kljucevi(7),
				ke1  => kljucevi(8),
				ke2  => kljucevi(9),
				k7  => kljucevi(10),
				k8  => kljucevi(11),
				k9  => kljucevi(12),
				k10  => kljucevi(13),
				k11  => kljucevi(14),
				k12  => kljucevi(15),
				ke3  => kljucevi(16),
				ke4  => kljucevi(17),
				k13  => kljucevi(18),
				k14  => kljucevi(19),
				k15  => kljucevi(20),
				k16  => kljucevi(21),
				k17  => kljucevi(22),
				k18  => kljucevi(23),
				kw3  => kljucevi(24),
				kw4  => kljucevi(25)
				);	
				
	data_randomizing_int: data_randomizing
		port map(
				data_in  => data_in_int,
				kw1  => kljucevi(0),
				kw2  => kljucevi(1),
				k1  => kljucevi(2),
				k2  => kljucevi(3),
				k3  => kljucevi(4),
				k4  => kljucevi(5),
				k5  => kljucevi(6),
				k6  => kljucevi(7),
				ke1  => kljucevi(8),
				ke2  => kljucevi(9),
				k7  => kljucevi(10),
				k8  => kljucevi(11),
				k9  => kljucevi(12),
				k10  => kljucevi(13),
				k11  => kljucevi(14),
				k12  => kljucevi(15),
				ke3  => kljucevi(16),
				ke4  => kljucevi(17),
				k13  => kljucevi(18),
				k14  => kljucevi(19),
				k15  => kljucevi(20),
				k16  => kljucevi(21),
				k17  => kljucevi(22),
				k18  => kljucevi(23),
				kw3  => kljucevi(24),
				kw4  => kljucevi(25),
				data_out => data_out_int
				);	
		
	
		data_out  <= data_out_int ;
		
end shema;