library IEEE;
use IEEE.std_logic_1164.all;


entity data_randomizing is
    port(
		data_in: in  STD_LOGIC_VECTOR (0 to 127);
		k1: in    STD_LOGIC_VECTOR (0 to 63);
		k2: in    STD_LOGIC_VECTOR (0 to 63);
		k3: in    STD_LOGIC_VECTOR (0 to 63);
		k4: in    STD_LOGIC_VECTOR (0 to 63);
		k5: in    STD_LOGIC_VECTOR (0 to 63);
		k6: in    STD_LOGIC_VECTOR (0 to 63);
		k7: in    STD_LOGIC_VECTOR (0 to 63);
		k8: in    STD_LOGIC_VECTOR (0 to 63);
		k9: in    STD_LOGIC_VECTOR (0 to 63);
		k10: in    STD_LOGIC_VECTOR (0 to 63);
		k11: in    STD_LOGIC_VECTOR (0 to 63);
		k12: in    STD_LOGIC_VECTOR (0 to 63); 
		k13: in    STD_LOGIC_VECTOR (0 to 63);
		k14: in    STD_LOGIC_VECTOR (0 to 63);
		k15: in    STD_LOGIC_VECTOR (0 to 63);
		k16: in    STD_LOGIC_VECTOR (0 to 63);
		k17: in    STD_LOGIC_VECTOR (0 to 63);
		k18: in    STD_LOGIC_VECTOR (0 to 63);
		kw1: in    STD_LOGIC_VECTOR (0 to 63);
		kw2: in    STD_LOGIC_VECTOR (0 to 63);
		kw3: in    STD_LOGIC_VECTOR (0 to 63);
		kw4: in    STD_LOGIC_VECTOR (0 to 63);
		ke1: in    STD_LOGIC_VECTOR (0 to 63);
		ke2: in    STD_LOGIC_VECTOR (0 to 63);
		ke3: in    STD_LOGIC_VECTOR (0 to 63);
		ke4: in    STD_LOGIC_VECTOR (0 to 63);
		data_out: out  STD_LOGIC_VECTOR (0 to 127)
		);
end data_randomizing;

architecture shema of data_randomizing is
		
	signal d1: STD_LOGIC_VECTOR (0 to 63);
	signal d2: STD_LOGIC_VECTOR (0 to 63);
	signal int1: STD_LOGIC_VECTOR (0 to 63);
	signal int2: STD_LOGIC_VECTOR (0 to 63);
	signal int3: STD_LOGIC_VECTOR (0 to 63);
	signal int4: STD_LOGIC_VECTOR (0 to 63);
	signal int5: STD_LOGIC_VECTOR (0 to 63);
	signal int6: STD_LOGIC_VECTOR (0 to 63);
	signal int7: STD_LOGIC_VECTOR (0 to 63);
	signal int8: STD_LOGIC_VECTOR (0 to 63);
	signal int9: STD_LOGIC_VECTOR (0 to 63);
	signal int10: STD_LOGIC_VECTOR (0 to 63);
	signal int11: STD_LOGIC_VECTOR (0 to 63);
	signal int12: STD_LOGIC_VECTOR (0 to 63);
	signal int13: STD_LOGIC_VECTOR (0 to 63);
	signal int14: STD_LOGIC_VECTOR (0 to 63);
	
	type niz_registara is array (0 to 25) of std_logic_vector(0 to 63);
	signal kljucevi: niz_registara;
	
	component sest_rundi is
        port (
				d1_in: in STD_LOGIC_VECTOR (0 to 63);
				d2_in: in STD_LOGIC_VECTOR (0 to 63);
				k1: in    STD_LOGIC_VECTOR (0 to 63);
				k2: in    STD_LOGIC_VECTOR (0 to 63);
				k3: in    STD_LOGIC_VECTOR (0 to 63);
				k4: in    STD_LOGIC_VECTOR (0 to 63);
				k5: in    STD_LOGIC_VECTOR (0 to 63);
				k6: in    STD_LOGIC_VECTOR (0 to 63);
				d1_out: out STD_LOGIC_VECTOR (0 to 63);
				d2_out: out STD_LOGIC_VECTOR (0 to 63)
				);
		end component;
		
	component FL is
        port (
				fl_in:in  STD_LOGIC_VECTOR (0 to 63);
				fl_k:in  STD_LOGIC_VECTOR (0 to 63);
				fl_out: out  STD_LOGIC_VECTOR (0 to 63);
				fli_in:in  STD_LOGIC_VECTOR (0 to 63);
				fli_k:in  STD_LOGIC_VECTOR (0 to 63);
				fli_out: out  STD_LOGIC_VECTOR (0 to 63)
				);
		end component;
		
	begin
      
		sest_rundi_inst1: sest_rundi
		port map(
				d1_in  => int1,
				d2_in => int2,
				k1 => kljucevi(0),
				k2 => kljucevi(1),
				k3 => kljucevi(2),
				k4 => kljucevi(3),
				k5 => kljucevi(4),
				k6 => kljucevi(5),
				d1_out  => int3,
				d2_out  => int4
				);
	
		FL1:FL
		port map(
				fl_in =>int3,
				fl_k => kljucevi(6),
				fl_out => int5,
				fli_in =>int4,
				fli_k => kljucevi(7),
				fli_out => int6
				);
	
		sest_rundi_inst2: sest_rundi
		port map(
				d1_in  => int5,
				d2_in => int6,
				k1 => kljucevi(8),
				k2 => kljucevi(9),
				k3 => kljucevi(10),
				k4 => kljucevi(11),
				k5 => kljucevi(12),
				k6 => kljucevi(13),
				d1_out  => int7,
				d2_out  => int8
				);
		
		FL2:FL
		port map(
				fl_in => int7,
				fl_k => kljucevi(14),
				fl_out => int9,
				fli_in => int8,
				fli_k => kljucevi(15),
				fli_out => int10
				);
		
		sest_rundi_inst3: sest_rundi
		port map(
				d1_in  => int9,
				d2_in => int10,
				k1 => kljucevi(16),
				k2 => kljucevi(17),
				k3 => kljucevi(18),
				k4 => kljucevi(19),
				k5 => kljucevi(20),
				k6 => kljucevi(21),
				d1_out  => int11,
				d2_out  => int12
				);

		kljucevi(0) <= k1;
		kljucevi(1) <= k2;
		kljucevi(2) <= k3;
		kljucevi(3) <= k4;
		kljucevi(4) <= k5;
		kljucevi(5) <= k6;
		kljucevi(6) <= ke1;
		kljucevi(7) <= ke2;
		kljucevi(8) <= k7;
		kljucevi(9) <= k8;
		kljucevi(10) <= k9;
		kljucevi(11) <= k10;
		kljucevi(12) <= k11;
		kljucevi(13) <= k12;
		kljucevi(14) <= ke3;
		kljucevi(15) <= ke4;
		kljucevi(16) <= k13;
		kljucevi(17) <= k14;
		kljucevi(18) <= k15;
		kljucevi(19) <= k16;
		kljucevi(20) <= k17;
		kljucevi(21) <= k18;
		kljucevi(22) <= kw1;
		kljucevi(23) <= kw2;
		kljucevi(24) <= kw3;
		kljucevi(25) <= kw4;
	
		d1 <= data_in(0 to 63);
		d2 <= data_in(64 to 127);
		int1 <= d1 xor kljucevi(22);
		int2 <= d2 xor kljucevi(23);
		int13 <= int12 xor kljucevi(24);
		int14 <= int11 xor kljucevi(25);
		data_out <= int13&int14;


end shema;