library IEEE;
use IEEE.std_logic_1164.all;

entity F is
    port(
        f_in : in STD_LOGIC_VECTOR (0 to 63);
        ke : in STD_LOGIC_VECTOR (0 to 63);
        f_out : out STD_LOGIC_VECTOR (0 to 63)
        );
end F;

architecture shema of F is

	signal x : STD_LOGIC_VECTOR (0 to 63);
	signal t1, t2, t3, t4, t5, t6, t7, t8 : STD_LOGIC_VECTOR (0 to 7);
	signal y : STD_LOGIC_VECTOR (0 to 63);
	signal t01, t02, t03, t04, t05, t06, t07, t08: STD_LOGIC_VECTOR (0 to 7);
	
	component sbox1 is
        port(
            sbox1_in  : in   STD_LOGIC_VECTOR (0 to 7);
			sbox1_out : out  STD_LOGIC_VECTOR (0 to 7)
			);
		end component;
	
	component sbox2 is
        port(
            sbox2_in  : in   STD_LOGIC_VECTOR (0 to 7);
			sbox2_out : out  STD_LOGIC_VECTOR (0 to 7)
			);
		end component;
	
	component sbox3 is
        port(
            sbox3_in  : in   STD_LOGIC_VECTOR (0 to 7);
			sbox3_out : out  STD_LOGIC_VECTOR (0 to 7)
			);
		end component;
	
	component sbox4 is
        port(
            sbox4_in  : in   STD_LOGIC_VECTOR (0 to 7);
			sbox4_out : out  STD_LOGIC_VECTOR (0 to 7)
			);
		end component;
	
begin
 
		x<= f_in xor ke;
		t1<= x(0 to 7);
		t2<= x(8 to 15);
		t3<= x(16 to 23);
		t4<= x(24 to 31);
		t5<= x(32 to 39);
		t6<= x(40 to 47);
		t7<= x(48 to 55);
		t8<= x(56 to 63);
  
		S1a : sbox1
        port map(
				sbox1_in => t1,
				sbox1_out => t01
				); 
		
		S1b : sbox1
        port map(
				sbox1_in => t8,
				sbox1_out => t08
				);
		
		S2a : sbox2
        port map(
				sbox2_in => t2,
				sbox2_out =>t02
				);
		
		S2b : sbox2
        port map(
				sbox2_in => t5,
				sbox2_out => t05
				);
		
		S3a : sbox3
        port map(
				sbox3_in => t3,
				sbox3_out =>t03
				);
		
		S3b : sbox3
        port map(
				sbox3_in => t6, 
				sbox3_out => t06
				);
		
		S4a : sbox4
		port map(
				sbox4_in => t4,
				sbox4_out => t04
				);
		
		S4b : sbox4
        port map(
				sbox4_in => t7,
				sbox4_out => t07
				);
			
			
		y(0 to 7)<=t01 xor t03 xor t04 xor t06 xor t07 xor t08;
		y(8 to 15)<=t01 xor t02 xor t04 xor t05 xor t07 xor t08;
		y(16 to 23)<=t01 xor t02 xor t03 xor t05 xor t06 xor t08;
		y(24 to 31)<=t02 xor t03 xor t04 xor t05 xor t06 xor t07;
		y(32 to 39)<=t01 xor t02 xor t06 xor t07 xor t08;
		y(40 to 47)<=t02 xor t03 xor t05 xor t07 xor t08;
		y(48 to 55)<=t03 xor t04 xor t05 xor t06 xor t08;
		y(56 to 63)<=t01 xor t04 xor t05 xor t06 xor t07;
  
		f_out<=y;
  
  
  
end shema;