library IEEE;
use IEEE.std_logic_1164.all;

entity generisanje_ka is
	port(
		k: in STD_LOGIC_VECTOR (0 to 127);
		ka: out STD_LOGIC_VECTOR (0 to 127)
		);
end generisanje_ka;

architecture shema of generisanje_ka is

	signal kl: STD_LOGIC_VECTOR (0 to 127);
	signal kr: STD_LOGIC_VECTOR (0 to 127);
	signal d: STD_LOGIC_VECTOR (0 to 127);
	signal d1: STD_LOGIC_VECTOR (0 to 63);
	signal d2: STD_LOGIC_VECTOR (0 to 63);
	constant sigma1 : STD_LOGIC_VECTOR (0 to 63) := X"A09E667F3BCC908B";
    constant sigma2 : STD_LOGIC_VECTOR (0 to 63) := X"B67AE8584CAA73B2";
    constant sigma3 : STD_LOGIC_VECTOR (0 to 63) := X"C6EF372FE94F82BE";
    constant sigma4 : STD_LOGIC_VECTOR (0 to 63) := X"54FF53A5F1D36F1C";
    constant sigma5 : STD_LOGIC_VECTOR (0 to 63) := X"10E527FADE682D1D";
    constant sigma6 : STD_LOGIC_VECTOR (0 to 63) := X"B05688C2B3E6C1FD";
	signal int1: STD_LOGIC_VECTOR (0 to 63);
	signal int2: STD_LOGIC_VECTOR (0 to 63);
	signal int3: STD_LOGIC_VECTOR (0 to 63);
	signal int4: STD_LOGIC_VECTOR (0 to 63);
	signal d21: STD_LOGIC_VECTOR (0 to 63);
	signal d11: STD_LOGIC_VECTOR (0 to 63);
	signal y: STD_LOGIC_VECTOR (0 to 127);
	signal z: STD_LOGIC_VECTOR (0 to 127);
	signal z1: STD_LOGIC_VECTOR (0 to 63);
	signal z2: STD_LOGIC_VECTOR (0 to 63);
	signal z21: STD_LOGIC_VECTOR (0 to 63);
	signal z11: STD_LOGIC_VECTOR (0 to 63);
	
	component F is
        port(
			f_in     : in STD_LOGIC_VECTOR (0 to 63);
            ke     : in STD_LOGIC_VECTOR (0 to 63);
            f_out     : out STD_LOGIC_VECTOR (0 to 63)
			);
	end component;
	
begin
		kl <= k;
		kr <= (others => '0');
		d <= kl xor kr;
		d1 <= d(0 to 63);
		d2 <= d(64 to 127);
	 
		F1: F
		port map(
				f_in  => d1,
				ke => sigma1,
				f_out => int1			
				);
				
		d21 <= d2 xor int1;
	
		F2: F
		port map(
				f_in  => d21,
				ke => sigma2,
				f_out => int2			
				);	
	 
		d11 <= d1 xor int2;
	
		y <= d11&d21;
		z <= y xor kl;
		z1 <= z(0 to 63);
		z2 <= z(64 to 127);
		
		F3: F
		port map(
				f_in  => z1,
				ke => sigma3,
				f_out => int3			
				);	
	 
		z21 <= z2 xor int3;
		
		F4: F
		port map(
				f_in  => z21,
				ke => sigma4,
				f_out => int4			
				);	
	 
		z11 <= z1 xor int4;
		
		ka <= z11&z21;

end shema;
	 
	 