library IEEE;
use IEEE.std_logic_1164.all;

entity key_scheduling is
	port(
		k: in STD_LOGIC_VECTOR (0 to 127);
		kw1: out STD_LOGIC_VECTOR (0 to 63);
		kw2: out STD_LOGIC_VECTOR (0 to 63);
		kw3: out STD_LOGIC_VECTOR (0 to 63);
		kw4: out STD_LOGIC_VECTOR (0 to 63);
		k1: out STD_LOGIC_VECTOR (0 to 63);
		k2: out STD_LOGIC_VECTOR (0 to 63);
		k3: out STD_LOGIC_VECTOR (0 to 63);
		k4: out STD_LOGIC_VECTOR (0 to 63);
		k5: out STD_LOGIC_VECTOR (0 to 63);
		k6: out STD_LOGIC_VECTOR (0 to 63);
		k7: out STD_LOGIC_VECTOR (0 to 63);
		k8: out STD_LOGIC_VECTOR (0 to 63);
		k9: out STD_LOGIC_VECTOR (0 to 63);
		k10: out STD_LOGIC_VECTOR (0 to 63);
		k11: out STD_LOGIC_VECTOR (0 to 63);
		k12: out STD_LOGIC_VECTOR (0 to 63);
		k13: out STD_LOGIC_VECTOR (0 to 63);
		k14: out STD_LOGIC_VECTOR (0 to 63);
		k15: out STD_LOGIC_VECTOR (0 to 63);
		k16: out STD_LOGIC_VECTOR (0 to 63);
		k17: out STD_LOGIC_VECTOR (0 to 63);
		k18: out STD_LOGIC_VECTOR (0 to 63);
		ke1: out STD_LOGIC_VECTOR (0 to 63);
		ke2: out STD_LOGIC_VECTOR (0 to 63);
		ke3: out STD_LOGIC_VECTOR (0 to 63);
		ke4: out STD_LOGIC_VECTOR (0 to 63)
		);
end key_scheduling;

architecture shema of key_scheduling is
	signal k_int:STD_LOGIC_VECTOR (0 to 127);
	signal ka_int:STD_LOGIC_VECTOR (0 to 127);
	signal int1, int2, int3, int4, int5, int6, int7, int8, int9, int10, int11, int12:STD_LOGIC_VECTOR (0 to 127);
	type niz_registara is array (0 to 25) of std_logic_vector(0 to 63);
	signal kljucevi: niz_registara;
	
	component generisanje_ka is
        port(
			k: in STD_LOGIC_VECTOR (0 to 127);
			ka: out STD_LOGIC_VECTOR (0 to 127)
			);
	end component;
	
begin

		 k_int <= k;
	 
		generisanje_ka_int: generisanje_ka
		port map(
				k  => k_int,
				ka => ka_int			
				);	
				
		kljucevi(0) <= k_int(0 to 63);
		kljucevi(1) <= k_int(64 to 127);
		
		kljucevi(2) <= ka_int(0 to 63);
		kljucevi(3) <= ka_int(64 to 127);
		
		int1 <= k_int(15 to 127)&k_int(0 to 14);
		
		kljucevi(4) <= int1(0 to 63);
		kljucevi(5) <= int1(64 to 127);
		
		int2 <= ka_int(15 to 127)&ka_int(0 to 14);
		
		kljucevi(6) <= int2(0 to 63);
		kljucevi(7) <= int2(64 to 127);
		
		int3 <= ka_int(30 to 127)&ka_int(0 to 29);
		
		kljucevi(8) <= int3(0 to 63);
		kljucevi(9) <= int3(64 to 127);
		
		int4 <= k_int(45 to 127)&k_int(0 to 44);
		
		kljucevi(10) <= int4(0 to 63);
		kljucevi(11) <= int4(64 to 127);
		
		int5 <=ka_int(45 to 127)&ka_int(0 to 44);
		
		kljucevi(12) <= int5(0 to 63);
		
		int6 <= k_int(60 to 127)&k_int(0 to 59);
		
		kljucevi(13) <= int6(64 to 127);
		
		int7 <= ka_int(60 to 127)&ka_int(0 to 59);
		
		kljucevi(14) <= int7(0 to 63);
		kljucevi(15) <= int7(64 to 127);
		
		int8 <= k_int(77 to 127)&k_int(0 to 76);
		
		kljucevi(16) <= int8(0 to 63);
		kljucevi(17) <= int8(64 to 127);
		
		int9 <= k_int(94 to 127)&k_int(0 to 93);
		
		kljucevi(18) <= int9(0 to 63);
		kljucevi(19) <= int9(64 to 127);
		
		int10 <= ka_int(94 to 127)&ka_int(0 to 93);
		
		kljucevi(20) <= int10(0 to 63);
		kljucevi(21) <= int10(64 to 127);
		
		int11 <= k_int(111 to 127)&k_int(0 to 110);
		
		kljucevi(22) <= int11(0 to 63);
		kljucevi(23) <= int11(64 to 127);
		
		int12 <= ka_int(111 to 127)&ka_int(0 to 110);
		
		kljucevi(24) <= int12(0 to 63);
		kljucevi(25) <= int12(64 to 127);
	
		kw1 <= kljucevi(0);
		kw2 <= kljucevi(1);
		k1 <= kljucevi(2);
		k2 <= kljucevi(3);
		k3 <= kljucevi(4);
		k4 <= kljucevi(5);
		k5 <= kljucevi(6);
		k6 <= kljucevi(7);
		ke1 <= kljucevi(8);
		ke2 <= kljucevi(9);
		k7 <= kljucevi(10);
		k8 <= kljucevi(11);
		k9 <= kljucevi(12);
		k10 <= kljucevi(13);
		k11 <= kljucevi(14);
		k12 <= kljucevi(15);
		ke3 <= kljucevi(16);
		ke4 <= kljucevi(17);
		k13 <= kljucevi(18);
		k14 <= kljucevi(19);
		k15 <= kljucevi(20);
		k16 <= kljucevi(21);
		k17 <= kljucevi(22);
		k18 <= kljucevi(23);
		kw3 <= kljucevi(24);
		kw4 <= kljucevi(25);
	
end shema;
	