library IEEE;
use IEEE.std_logic_1164.all;


entity sest_rundi is
    port(
		d1_in: in STD_LOGIC_VECTOR (0 to 63);
		d2_in: in STD_LOGIC_VECTOR (0 to 63);
		k1: in    STD_LOGIC_VECTOR (0 to 63);
		k2: in    STD_LOGIC_VECTOR (0 to 63);
		k3: in    STD_LOGIC_VECTOR (0 to 63);
		k4: in    STD_LOGIC_VECTOR (0 to 63);
		k5: in    STD_LOGIC_VECTOR (0 to 63);
		k6: in    STD_LOGIC_VECTOR (0 to 63);
		d1_out: out STD_LOGIC_VECTOR (0 to 63);
		d2_out: out STD_LOGIC_VECTOR (0 to 63)
		);
end sest_rundi;
	
architecture shema of sest_rundi is
    
	type niz_registara is array (0 to 5) of STD_LOGIC_VECTOR(0 to 63);
	signal kljucevi: niz_registara;
	signal int1: STD_LOGIC_VECTOR (0 to 63);
	signal int2: STD_LOGIC_VECTOR (0 to 63);
	signal int3: STD_LOGIC_VECTOR (0 to 63);
	signal int4: STD_LOGIC_VECTOR (0 to 63);
	signal int5: STD_LOGIC_VECTOR (0 to 63);
	signal int6: STD_LOGIC_VECTOR (0 to 63);
	signal d21: STD_LOGIC_VECTOR (0 to 63);
	signal d22: STD_LOGIC_VECTOR (0 to 63);
	signal d23: STD_LOGIC_VECTOR (0 to 63);
	signal d11: STD_LOGIC_VECTOR (0 to 63);
	signal d12: STD_LOGIC_VECTOR (0 to 63);
	signal d13: STD_LOGIC_VECTOR (0 to 63);
	
	component F is
        port(
			f_in     : in STD_LOGIC_VECTOR (0 to 63);
            ke     : in STD_LOGIC_VECTOR (0 to 63);
            f_out     : out STD_LOGIC_VECTOR (0 to 63)
			);
	end component;
		
begin
	
		runda1: F
		port map(
				f_in  => d1_in,
				ke => kljucevi(0),
				f_out => int1			
				);
				
		runda2: F
		port map(
				f_in  =>d21 ,
				ke => kljucevi(1),
				f_out => int2			
				);
				
		runda3: F
		port map(
				f_in  => d11,
				ke => kljucevi(2),
				f_out => int3			
				);
				
		runda4: F
		port map(
				f_in  => d22,
				ke => kljucevi(3),
				f_out => int4			
				);
				
		runda5: F
		port map(
				f_in  => d12,
				ke => kljucevi(4),
				f_out => int5			
				);
				
		runda6: F
		port map(
				f_in  => d23,
				ke => kljucevi(5),
				f_out => int6		
				);
	
		kljucevi(0) <= k1;
		kljucevi(1) <= k2;
		kljucevi(2) <= k3;
		kljucevi(3) <= k4;
		kljucevi(4) <= k5;
		kljucevi(5) <= k6;
		
		d21 <= d2_in xor int1;
		d11 <=d1_in xor int2;
		d22 <= d21 xor int3;
		d12 <= d11 xor int4;
		d23 <= d22 xor int5;
		d13 <= d12 xor int6;
		
		d1_out <= d13;
		d2_out <= d23;
		
end shema;
		